diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index a42767895dc..8917d28f94b 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -138,7 +138,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_acquire(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr);
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count);
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff);
 static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
@@ -233,6 +233,12 @@ static INT find_joystick_devices(void)
         joydev.button_count = 2;
 #endif
 
+        if (joydev.button_count > 128)
+        {
+            WARN("Can't support %d buttons. Clamping down to 128\n", joydev.button_count);
+            joydev.button_count = 128;
+        }
+
         joydev.is_joystick = FALSE;
         if (ioctl(fd, JSIOCGBTNMAP, btn_map) < 0)
         {
@@ -508,19 +514,11 @@ static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis
     *axes_map = This->joydev->axes_map;
 }
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count)
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     int i, idx = 0, wine_obj;
 
-    This->generic.devcaps.dwButtons = This->joydev->button_count;
-
-    if (This->generic.devcaps.dwButtons > 128)
-    {
-        WARN("Can't support %d buttons. Clamping down to 128\n", This->generic.devcaps.dwButtons);
-        This->generic.devcaps.dwButtons = 128;
-    }
-
     for (i = 0; i < This->joydev->axis_count; i++)
     {
         if ((idx = This->joydev->axes_map[i]) >= 0)
@@ -531,24 +529,10 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
             else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
         }
     }
-    for (i = 0; i < This->generic.devcaps.dwButtons; i++)
+    for (i = 0; i < This->joydev->button_count; i++)
         props[i + 12].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_PSHBUTTON;
     *prop_count = i + 12;
-
-    This->generic.devcaps.dwSize = sizeof(This->generic.devcaps);
-    This->generic.devcaps.dwFlags = DIDC_ATTACHED;
-    This->generic.devcaps.dwDevType = This->generic.base.info.dwDevType;
-
-    This->generic.devcaps.dwFFSamplePeriod = 0;
-    This->generic.devcaps.dwFFMinTimeResolution = 0;
-    This->generic.devcaps.dwFirmwareRevision = 0;
-    This->generic.devcaps.dwHardwareRevision = 0;
-    This->generic.devcaps.dwFFDriverVersion = 0;
-
-    if (TRACE_ON(dinput)) {
-        for (i = 0; i < (This->joydev->axis_count); i++) TRACE("axis_map[%d] = %d\n", i, This->generic.axis_map[i]);
-        _dump_DIDEVCAPS(&This->generic.devcaps);
-    }
+    *has_ff = FALSE;
 
     return DI_OK;
 }
@@ -635,7 +619,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
               jse.type,jse.number,jse.value);
         if (jse.type & JS_EVENT_BUTTON)
         {
-            if (jse.number >= This->generic.devcaps.dwButtons) return;
+            if (jse.number >= This->joydev->button_count) return;
 
             inst_id = DIDFT_MAKEINSTANCE(jse.number) | DIDFT_PSHBUTTON;
             This->generic.js.rgbButtons[jse.number] = value = jse.value ? 0x80 : 0x00;
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 152aa1a6934..3e65373badc 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -172,7 +172,7 @@ static HRESULT CDECL unix_joystick_get_effect_info(struct unix_joystick *ptr, RE
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect,
         struct list *entry, IDirectInputEffect **out);
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count);
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff);
 static void CDECL unix_joystick_reset(struct unix_joystick *ptr);
 static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
 
@@ -560,7 +560,7 @@ static void CDECL unix_joystick_get_mapping(struct unix_joystick *ptr, int *axis
     *axes_map = This->joydev->axes_map;
 }
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count)
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     int i, idx = 0, wine_obj;
@@ -574,8 +574,6 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
        enabled. */
     This->ff_autocenter = 1;
     This->ff_gain = 0xFFFF;
-    This->generic.ff_autocenter = DIPROPAUTOCENTER_ON;
-    This->generic.ff_gain = 10000;
 
     /* Count number of available axes - supported Axis & POVs */
     for (i = 0; i < ABS_MAX; i++)
@@ -622,14 +620,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     for (i = 0; i < This->joydev->button_count; i++)
         props[i + 12].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_PSHBUTTON;
     *prop_count = i + 12;
-    This->generic.devcaps.dwButtons = This->joydev->button_count;
-
-    /* Fill the caps */
-    This->generic.devcaps.dwSize = sizeof(This->generic.devcaps);
-    This->generic.devcaps.dwFlags = DIDC_ATTACHED;
-    This->generic.devcaps.dwDevType = This->generic.base.info.dwDevType;
-
-    if (This->joydev->has_ff) This->generic.devcaps.dwFlags |= DIDC_FORCEFEEDBACK;
+    *has_ff = This->joydev->has_ff;
 
     return DI_OK;
 }
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 380d52a52ad..c773b49e355 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -719,16 +719,9 @@ static void get_osx_device_elements(JoystickImpl *device, int axis_map[8])
         /* Sort buttons into correct order */
         CFArraySortValues(buttons, CFRangeMake(0, CFArrayGetCount(buttons)), button_usage_comparator, NULL);
 
-        device->generic.devcaps.dwAxes = CFArrayGetCount(axes);
-        device->generic.devcaps.dwButtons = CFArrayGetCount(buttons);
-        device->generic.devcaps.dwPOVs = CFArrayGetCount(povs);
-
-        TRACE("axes %u povs %u buttons %u\n", device->generic.devcaps.dwAxes, device->generic.devcaps.dwPOVs,
-              device->generic.devcaps.dwButtons);
-
         /* build our element array in the order that dinput expects */
-        CFArrayAppendArray(axes, povs, CFRangeMake(0, device->generic.devcaps.dwPOVs));
-        CFArrayAppendArray(axes, buttons, CFRangeMake(0, device->generic.devcaps.dwButtons));
+        CFArrayAppendArray(axes, povs, CFRangeMake(0, CFArrayGetCount(povs)));
+        CFArrayAppendArray(axes, buttons, CFRangeMake(0, CFArrayGetCount(buttons)));
         device->elements = axes;
         axes = NULL;
 
@@ -736,12 +729,6 @@ static void get_osx_device_elements(JoystickImpl *device, int axis_map[8])
         CFRelease(buttons);
         CFRelease(elements);
     }
-    else
-    {
-        device->generic.devcaps.dwAxes = 0;
-        device->generic.devcaps.dwButtons = 0;
-        device->generic.devcaps.dwPOVs = 0;
-    }
 }
 
 static BOOL osx_axis_has_ff(FFCAPABILITIES *ffcaps, UInt8 axis);
@@ -1005,7 +992,7 @@ static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *params,
         struct list *entry, IDirectInputEffect **out);
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count);
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff);
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
@@ -1194,7 +1181,7 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
     return DI_OK;
 }
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count)
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     IOHIDDeviceRef device;
@@ -1213,7 +1200,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     list_init(&This->generic.ff_effects);
     if (get_ff(device, &This->ff) == S_OK)
     {
-        This->generic.devcaps.dwFlags |= DIDC_FORCEFEEDBACK;
+        *has_ff = TRUE;
 
         hr = FFDeviceGetForceFeedbackCapabilities(This->ff, &ffcaps);
         if(SUCCEEDED(hr)){
@@ -1241,36 +1228,14 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
         if(FAILED(hr))
             WARN("FFDeviceSendForceFeedbackCommand(FFSFFC_SETACTUATORSON) failed: %08x\n", hr);
     }
+    else *has_ff = FALSE;
 
     memset(axis_map, 0, sizeof(axis_map));
     get_osx_device_elements(This, axis_map);
 
-    TRACE("%i axes %i buttons %i povs\n", This->generic.devcaps.dwAxes, This->generic.devcaps.dwButtons,
-            This->generic.devcaps.dwPOVs);
-
-    if (This->generic.devcaps.dwButtons > 128)
-    {
-        WARN("Can't support %d buttons. Clamping down to 128\n", This->generic.devcaps.dwButtons);
-        This->generic.devcaps.dwButtons = 128;
-    }
-
     /* initialize default properties */
     get_osx_device_elements_props(This, &ffcaps, props, prop_count);
 
-    This->generic.devcaps.dwSize = sizeof(This->generic.devcaps);
-    This->generic.devcaps.dwFlags |= DIDC_ATTACHED;
-    This->generic.devcaps.dwDevType = This->generic.base.info.dwDevType;
-    This->generic.devcaps.dwFFSamplePeriod = 0;
-    This->generic.devcaps.dwFFMinTimeResolution = 0;
-    This->generic.devcaps.dwFirmwareRevision = 0;
-    This->generic.devcaps.dwHardwareRevision = 0;
-    This->generic.devcaps.dwFFDriverVersion = 0;
-
-    if (TRACE_ON(dinput)) {
-        TRACE("allocated device %p\n", This);
-        _dump_DIDEVCAPS(&This->generic.devcaps);
-    }
-
     return DI_OK;
 }
 
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 6fe1bfce0a9..554d0799b4c 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -37,7 +37,7 @@ struct unix_joystick;
 
 struct unix_joystick_vtbl
 {
-    HRESULT (CDECL *init)(struct unix_joystick *ptr, ObjProps *props, int *prop_count);
+    HRESULT (CDECL *init)(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff);
     void (CDECL *reset)(struct unix_joystick *ptr);
 
     void (CDECL *get_mapping)(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
@@ -89,8 +89,6 @@ HRESULT WINAPI JoystickWGenericImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
 
 HRESULT WINAPI JoystickWGenericImpl_GetCapabilities(LPDIRECTINPUTDEVICE8W iface, LPDIDEVCAPS lpDIDevCaps) DECLSPEC_HIDDEN;
 
-void _dump_DIDEVCAPS(const DIDEVCAPS *lpDIDevCaps) DECLSPEC_HIDDEN;
-
 HRESULT WINAPI JoystickWGenericImpl_SetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIPROPHEADER ph) DECLSPEC_HIDDEN;
 
 HRESULT WINAPI JoystickWGenericImpl_Acquire(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
-- 
2.28.0

>From 489a51e3ce98d7d4099ec77e96dee4d791e2c2cb Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 11:38:18 +0200
Subject: [PATCH 30/39] dinput: Introduce win32_funcs and use it for
 queue_event.

---
 dlls/dinput/dinput_main.c         |  7 +++++++
 dlls/dinput/dinput_private.h      |  7 +++++++
 dlls/dinput/joystick.c            |  5 +++++
 dlls/dinput/joystick_linux.c      | 16 +++-------------
 dlls/dinput/joystick_linuxinput.c | 17 +++--------------
 dlls/dinput/joystick_osx.c        | 19 +++++--------------
 dlls/dinput/joystick_private.h    |  2 ++
 7 files changed, 32 insertions(+), 41 deletions(-)

diff --git a/dlls/dinput/dinput_main.c b/dlls/dinput/dinput_main.c
index 43986029a50..112a29e91be 100644
--- a/dlls/dinput/dinput_main.c
+++ b/dlls/dinput/dinput_main.c
@@ -84,6 +84,13 @@ static const struct dinput_device *dinput_devices[] =
     &joystick_osx_device
 };
 
+const struct win32_funcs win32_entry =
+{
+    dinput_unix_joystick_queue_event,
+};
+
+const struct win32_funcs *win32_funcs = &win32_entry;
+
 HINSTANCE DINPUT_instance;
 
 static const WCHAR di_em_win_w[] = {'D','I','E','m','W','i','n',0};
diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index 9f3214eb260..7f603d303d4 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -64,6 +64,13 @@ struct dinput_device {
     HRESULT (*create_unix_joystick)(IDirectInputImpl *dinput, REFGUID rguid, JoystickGenericImpl **out);
 };
 
+typedef struct JoystickGenericImpl JoystickGenericImpl;
+
+struct win32_funcs
+{
+    void (CDECL *joystick_queue_event)(JoystickGenericImpl *This, int inst_id, DWORD data);
+};
+
 extern HRESULT dinput_create_device(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid,
         REFIID iid, void **out) DECLSPEC_HIDDEN;
 extern HRESULT dinput_enum_device(const struct dinput_device *device, DWORD type, DWORD flags, DIDEVICEINSTANCEW *didi,
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index de30e0aa073..39ccddb0032 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -1292,3 +1292,8 @@ done:
     if (FAILED(hr) && df) HeapFree(GetProcessHeap(), 0, df);
     return hr;
 }
+
+void CDECL dinput_unix_joystick_queue_event(JoystickGenericImpl *This, int inst_id, DWORD data)
+{
+    queue_event(&This->base.IDirectInputDevice8W_iface, inst_id, data, GetCurrentTime(), This->base.dinput->evsequence++);
+}
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 8917d28f94b..6bf04c51399 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -70,6 +70,8 @@
 
 WINE_DEFAULT_DEBUG_CHANNEL(dinput);
 
+extern const struct win32_funcs *win32_funcs DECLSPEC_HIDDEN;
+
 #define JOYDEV_NEW "/dev/input/js"
 #define JOYDEV_OLD "/dev/js"
 #define JOYDEVDRIVER " (js)"
@@ -102,16 +104,6 @@ struct JoystickImpl
         POINTL                          povs[4];
 };
 
-static inline JoystickImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
-{
-    return CONTAINING_RECORD(CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface),
-           JoystickGenericImpl, base), JoystickImpl, generic);
-}
-static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(JoystickImpl *This)
-{
-    return &This->generic.base.IDirectInputDevice8W_iface;
-}
-
 static inline struct unix_joystick *unix_joystick_from_impl(JoystickImpl *This)
 {
     return (struct unix_joystick *)This;
@@ -594,7 +586,6 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
     struct pollfd plfd;
     struct js_event jse;
     JoystickImpl *This = impl_from_unix_joystick(ptr);
-    IDirectInputDevice8W *iface = IDirectInputDevice8W_from_impl(This);
 
     TRACE("(%p)\n", This);
 
@@ -660,8 +651,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                     WARN("axis %d not supported\n", number);
             }
         }
-        if (inst_id >= 0)
-            queue_event(iface, inst_id, value, GetCurrentTime(), This->generic.base.dinput->evsequence++);
+        if (inst_id >= 0) win32_funcs->joystick_queue_event(&This->generic, inst_id, value);
     }
 }
 
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 3e65373badc..40a1f6a991f 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -68,6 +68,8 @@
 
 WINE_DEFAULT_DEBUG_CHANNEL(dinput);
 
+extern const struct win32_funcs *win32_funcs DECLSPEC_HIDDEN;
+
 #define EVDEVPREFIX "/dev/input/event"
 #define EVDEVDRIVER " (event)"
 
@@ -136,16 +138,6 @@ struct JoystickImpl
 	int				ff_gain;
 };
 
-static inline JoystickImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
-{
-    return CONTAINING_RECORD(CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface),
-           JoystickGenericImpl, base), JoystickImpl, generic);
-}
-static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(JoystickImpl *This)
-{
-    return &This->generic.base.IDirectInputDevice8W_iface;
-}
-
 static inline struct unix_joystick *unix_joystick_from_impl(JoystickImpl *This)
 {
     return (struct unix_joystick *)This;
@@ -765,7 +757,6 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
     struct pollfd plfd;
     struct input_event ie;
     JoystickImpl *This = impl_from_unix_joystick(ptr);
-    IDirectInputDevice8W *iface = IDirectInputDevice8W_from_impl(This);
 
     if (This->joyfd==-1)
 	return;
@@ -858,9 +849,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 	    TRACE("skipping event\n");
 	    break;
 	}
-        if (inst_id >= 0)
-            queue_event(iface, inst_id,
-                        value, GetCurrentTime(), This->generic.base.dinput->evsequence++);
+        if (inst_id >= 0) win32_funcs->joystick_queue_event(&This->generic, inst_id, value);
     }
 }
 
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index c773b49e355..d41dda7ddd0 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -96,6 +96,8 @@
 
 WINE_DEFAULT_DEBUG_CHANNEL(dinput);
 
+extern const struct win32_funcs *win32_funcs DECLSPEC_HIDDEN;
+
 static CFMutableArrayRef device_main_elements = NULL;
 
 typedef struct JoystickImpl JoystickImpl;
@@ -111,16 +113,6 @@ struct JoystickImpl
     FFDeviceObjectReference ff;
 };
 
-static inline JoystickImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
-{
-    return CONTAINING_RECORD(CONTAINING_RECORD(CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface),
-           JoystickGenericImpl, base), JoystickImpl, generic);
-}
-static inline IDirectInputDevice8W *IDirectInputDevice8W_from_impl(JoystickImpl *This)
-{
-    return &This->generic.base.IDirectInputDevice8W_iface;
-}
-
 static inline struct unix_joystick *unix_joystick_from_impl(JoystickImpl *This)
 {
     return (struct unix_joystick *)This;
@@ -815,7 +807,6 @@ static void get_osx_device_elements_props(JoystickImpl *device, FFCAPABILITIES *
 static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 {
     JoystickImpl *device = impl_from_unix_joystick(ptr);
-    IDirectInputDevice8W *iface = IDirectInputDevice8W_from_impl(device);
     IOHIDElementRef device_main_element;
     IOHIDDeviceRef hid_device;
 
@@ -866,7 +857,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                         if (oldVal != newVal)
                         {
                             inst_id = DIDFT_MAKEINSTANCE(button_idx) | DIDFT_PSHBUTTON;
-                            queue_event(iface,inst_id,newVal,GetCurrentTime(),device->generic.base.dinput->evsequence++);
+                            win32_funcs->joystick_queue_event(&device->generic, inst_id, newVal);
                         }
                         button_idx ++;
                     }
@@ -895,7 +886,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                             if (oldVal != newVal)
                             {
                                 inst_id = DIDFT_MAKEINSTANCE(pov_idx) | DIDFT_POV;
-                                queue_event(iface,inst_id,newVal,GetCurrentTime(),device->generic.base.dinput->evsequence++);
+                                win32_funcs->joystick_queue_event(&device->generic, inst_id, newVal);
                             }
                             pov_idx ++;
                             break;
@@ -968,7 +959,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                                  (oldVal != newVal))
                             {
                                 inst_id = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
-                                queue_event(iface,inst_id,newVal,GetCurrentTime(),device->generic.base.dinput->evsequence++);
+                                win32_funcs->joystick_queue_event(&device->generic, inst_id, newVal);
                             }
 
                             break;
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 554d0799b4c..1c0e2bc12be 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -82,6 +82,8 @@ DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
 
 extern BOOL device_disabled_registry(const WCHAR* name) DECLSPEC_HIDDEN;
 
+extern void CDECL dinput_unix_joystick_queue_event(JoystickGenericImpl *This, int inst_id, DWORD data) DECLSPEC_HIDDEN;
+
 HRESULT WINAPI JoystickWGenericImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W iface,
         LPDIDEVICEOBJECTINSTANCEW pdidoi, DWORD dwObj, DWORD dwHow) DECLSPEC_HIDDEN;
 
-- 
2.28.0

>From c8b0f704a2650fad638d79d554c2d945a1716817 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 16:10:49 +0200
Subject: [PATCH 31/39] dinput: Use the win32_funcs callbacks for user axis
 mapping.

---
 dlls/dinput/dinput_main.c         | 3 ++-
 dlls/dinput/dinput_private.h      | 1 +
 dlls/dinput/joystick.c            | 7 +++++++
 dlls/dinput/joystick_linux.c      | 4 ++--
 dlls/dinput/joystick_linuxinput.c | 8 ++++----
 dlls/dinput/joystick_private.h    | 1 +
 6 files changed, 17 insertions(+), 7 deletions(-)

diff --git a/dlls/dinput/dinput_main.c b/dlls/dinput/dinput_main.c
index 112a29e91be..66a65b7b55e 100644
--- a/dlls/dinput/dinput_main.c
+++ b/dlls/dinput/dinput_main.c
@@ -86,7 +86,8 @@ static const struct dinput_device *dinput_devices[] =
 
 const struct win32_funcs win32_entry =
 {
-    dinput_unix_joystick_queue_event,
+    dinput_unix_joystick_get_axis,
+    dinput_unix_joystick_queue_event
 };
 
 const struct win32_funcs *win32_funcs = &win32_entry;
diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index 7f603d303d4..58029d5b1f6 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -68,6 +68,7 @@ typedef struct JoystickGenericImpl JoystickGenericImpl;
 
 struct win32_funcs
 {
+    int (CDECL *joystick_get_axis)(JoystickGenericImpl *This, int index);
     void (CDECL *joystick_queue_event)(JoystickGenericImpl *This, int inst_id, DWORD data);
 };
 
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 39ccddb0032..e412f49a6e2 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -1293,6 +1293,13 @@ done:
     return hr;
 }
 
+int CDECL dinput_unix_joystick_get_axis(JoystickGenericImpl *This, int index)
+{
+    if (!This->axis_map) return index;
+    if (index < 0) return index;
+    return This->axis_map[index];
+}
+
 void CDECL dinput_unix_joystick_queue_event(JoystickGenericImpl *This, int inst_id, DWORD data)
 {
     queue_event(&This->base.IDirectInputDevice8W_iface, inst_id, data, GetCurrentTime(), This->base.dinput->evsequence++);
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 6bf04c51399..5f7ccf19514 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -515,7 +515,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     {
         if ((idx = This->joydev->axes_map[i]) >= 0)
         {
-            wine_obj = This->generic.axis_map[i];
+            wine_obj = win32_funcs->joystick_get_axis(&This->generic, i);
             if (wine_obj < 0) props[idx].dwType = 0;
             else if (wine_obj < 8) props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
             else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
@@ -617,7 +617,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
         }
         else if (jse.type & JS_EVENT_AXIS)
         {
-            int number = This->generic.axis_map[jse.number];	/* wine format object index */
+            int number = win32_funcs->joystick_get_axis(&This->generic, jse.number);
 
             if (number < 0) return;
             inst_id = number < 8 ?  DIDFT_MAKEINSTANCE(number) | DIDFT_ABSAXIS :
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 40a1f6a991f..4a21d67752f 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -575,7 +575,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
             props[idx].lDevMin = This->joydev->axes[i].minimum;
             props[idx].lDevMax = This->joydev->axes[i].maximum;
 
-            wine_obj = This->generic.axis_map[idx];
+            wine_obj = win32_funcs->joystick_get_axis(&This->generic, idx);
             if (wine_obj < 0) props[idx].dwType = 0;
             else if (wine_obj < 8) props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
             else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
@@ -591,7 +591,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
             props[idx].lDevMin = This->joydev->axes[ABS_HAT0X + i * 2].minimum;
             props[idx].lDevMax = This->joydev->axes[ABS_HAT0X + i * 2].maximum;
 
-            wine_obj = This->generic.axis_map[idx];
+            wine_obj = win32_funcs->joystick_get_axis(&This->generic, idx);
             if (wine_obj < 0) props[idx].dwType = 0;
             else if (wine_obj < 8) props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
             else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
@@ -602,7 +602,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
             props[idx].lDevMin = This->joydev->axes[ABS_HAT0Y + i * 2].minimum;
             props[idx].lDevMax = This->joydev->axes[ABS_HAT0Y + i * 2].maximum;
 
-            wine_obj = This->generic.axis_map[idx];
+            wine_obj = win32_funcs->joystick_get_axis(&This->generic, idx);
             if (wine_obj < 0) props[idx].dwType = 0;
             else if (wine_obj < 8) props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj) | DIDFT_ABSAXIS;
             else props[idx].dwType = DIDFT_MAKEINSTANCE(wine_obj - 8) | DIDFT_POV;
@@ -797,7 +797,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 
             /* User axis remapping */
             if (axis < 0) break;
-            axis = This->generic.axis_map[axis];
+            axis = win32_funcs->joystick_get_axis(&This->generic, axis);
             if (axis < 0) break;
 
             inst_id = axis < 8 ?  DIDFT_MAKEINSTANCE(axis) | DIDFT_ABSAXIS :
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 1c0e2bc12be..b088f6c851a 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -82,6 +82,7 @@ DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
 
 extern BOOL device_disabled_registry(const WCHAR* name) DECLSPEC_HIDDEN;
 
+extern int CDECL dinput_unix_joystick_get_axis(JoystickGenericImpl *This, int index) DECLSPEC_HIDDEN;
 extern void CDECL dinput_unix_joystick_queue_event(JoystickGenericImpl *This, int inst_id, DWORD data) DECLSPEC_HIDDEN;
 
 HRESULT WINAPI JoystickWGenericImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W iface,
-- 
2.28.0

>From e26b4d04f67d2ddaa1fa2c3f56b39f32b6d1df89 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 11:34:37 +0200
Subject: [PATCH 32/39] dinput: Update joystick button state on queue_event.

---
 dlls/dinput/dinput_private.h      |  2 +-
 dlls/dinput/joystick.c            | 14 ++++++++++++--
 dlls/dinput/joystick_linux.c      | 14 +++-----------
 dlls/dinput/joystick_linuxinput.c | 17 ++++-------------
 dlls/dinput/joystick_osx.c        | 24 ++++--------------------
 dlls/dinput/joystick_private.h    |  2 +-
 6 files changed, 25 insertions(+), 48 deletions(-)

diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index 58029d5b1f6..41819fbd425 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -69,7 +69,7 @@ typedef struct JoystickGenericImpl JoystickGenericImpl;
 struct win32_funcs
 {
     int (CDECL *joystick_get_axis)(JoystickGenericImpl *This, int index);
-    void (CDECL *joystick_queue_event)(JoystickGenericImpl *This, int inst_id, DWORD data);
+    void (CDECL *joystick_queue_event)(JoystickGenericImpl *This, WORD type, int index, DWORD data);
 };
 
 extern HRESULT dinput_create_device(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid,
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index e412f49a6e2..0a9c0b3f158 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -1300,7 +1300,17 @@ int CDECL dinput_unix_joystick_get_axis(JoystickGenericImpl *This, int index)
     return This->axis_map[index];
 }
 
-void CDECL dinput_unix_joystick_queue_event(JoystickGenericImpl *This, int inst_id, DWORD data)
+void CDECL dinput_unix_joystick_queue_event(JoystickGenericImpl *This, WORD type, int index, DWORD data)
 {
-    queue_event(&This->base.IDirectInputDevice8W_iface, inst_id, data, GetCurrentTime(), This->base.dinput->evsequence++);
+    DWORD didft = DIDFT_MAKEINSTANCE(index) | type;
+
+    switch (type)
+    {
+    case DIDFT_PSHBUTTON:
+        if (index < 0 || index >= This->devcaps.dwButtons) return;
+        This->js.rgbButtons[index] = data;
+        break;
+    }
+
+    queue_event(&This->base.IDirectInputDevice8W_iface, didft, data, GetCurrentTime(), This->base.dinput->evsequence++);
 }
